FrameworkApp.controller('PageContentCtrl', ['$scope', '$rootScope', function ($scope, $rootScope) {	
	if($rootScope.selectedLang == "ar"){
		$("#PageContent").attr("dir","rtl");	
	}
	// Video Completion handler 
	$scope.videoCompleteHandler = function(val){
		$("#vid_6_1").on('ended',function(){
			if(val=='skipNext'){
				$rootScope.gotoNextPage();
			}					
			else{
				$rootScope.markVisitedPage();
				$rootScope.isNextButtonDisabled = false;
			}
			$scope.$apply();	
		});
	}
	
	$scope.gamifiedPage = function(){
		if($rootScope.currentTopic+1 === $rootScope.CourseConfig.AssessmentSection && $rootScope.currentPage != 0 && $rootScope.pageStatusList[$rootScope.currentTopic].length-1 != $rootScope.currentPage)
			return true;
		else
			return false;
	}
	
	$scope.questionsArray = new Array(10);
	$scope.questionsArray[0] = Math.ceil(Math.random()*10);
	$rootScope.quizCounter = $scope.questionsArray[0];
	
	$scope.loadQuestion = function(e,indx){
	
		$scope.status_checker = $scope.crntQuizStatus(indx);
		
		if($scope.status_checker.cursor != undefined && $scope.status_checker.cursor == 'default'){
			return false;
		}
		$rootScope.blinkQuizWrapper=false;
		//if($scope.questionsArray.indexOf(indx) === -1){
			$scope.gotoNextPage();
			$rootScope.quizCounter = indx;
			$rootScope.isAnswered = false;
		//}
	}
	
	$scope.crntQuizStatus = function(ele){
		if($rootScope.isAnswered){
			if($rootScope.asmntScoreArray[ele-1] === 2){
				return {'cursor':'pointer','pointer-events':'all'};
			}else if($rootScope.asmntScoreArray[ele-1] === 1){
				return {'cursor':'default','pointer-events':'none','border':'none','visibility':'hidden'};
			}else if($rootScope.asmntScoreArray[ele-1] === 0){
				return {'cursor':'default','pointer-events':'none'};
			}
		}else{
			if(ele == $rootScope.quizCounter){
				return {'cursor':'default','pointer-events':'none'};
			}else if($rootScope.asmntScoreArray[ele-1] === 2){
				return {'cursor':'default','pointer-events':'none'};
			}else if($rootScope.asmntScoreArray[ele-1] === 1){
				return {'cursor':'default','pointer-events':'none','border':'none','visibility':'hidden'};
			}else if($rootScope.asmntScoreArray[ele-1] === 0){
				return {'cursor':'default','pointer-events':'none'};
			}
		}
	};
	
	$scope.setImage = function(indx){
		if($rootScope.asmntScoreArray[indx-1] == 2){
			return '../course_images/pages/assesment/quesmark.png';
		}else if($rootScope.asmntScoreArray[indx-1] == 0){
			return '../course_images/pages/assesment/Xmark.png';
		}else{
			return '../course_images/pages/assesment/transparent.png'
		}
	};
	
	$scope.getResult = function(){
		if($rootScope.assesmentScore >= 8)
			return 'Views/screens/certificate/'+$rootScope.selectedLang+'/passed.html';	
		else
			return 'Views/screens/certificate/'+$rootScope.selectedLang+'/failed.html';	
	};
   
}]);